import { Indexable } from '../indexable';

/**
 * Publication interface.
 * ~extends {@link Indexable}
 */
export interface Publication extends Indexable {
  /** The Id */
  'Id': number;
  /** The Article */
  'Article': string;
  /** The Article author */
  'Article author': string;
  /** The Article date */
  'Article date': string;
  /** The Title */
  'Title': string;
  /** The Subtitle */
  'Subtitle': string;
  /** The Translation Article */
  'Translation Article': string;
  /** The Translation Title */
  'Translation Title': string;
  /** The Translation Subtitle */
  'Translation Subtitle': string;
  /** The Translator */
  'Translator': string;
  /** The Editor */
  'Editor': string;
  /** The Publisher */
  'Publisher': string;
  /** The Publication date */
  'Publication date': string;
  /** The Type */
  'Type': string;
  /** The Author */
  'Author': string;
  /** The City */
  'City': string;
  /** The Page count */
  'Page count': string;
  /** The Pages */
  'Pages': string;
  /** The Size */
  'Size': string;
  /** The Format */
  'Format': string;
  /** The ISBN */
  'ISBN': string;
  /** The URL */
  'URL': string;
  /** The Publication image */
  'Publication image': string;
  /** The Description */
  'Description': any[];
  /** The Color */
  'Color': string;
}
